/*
 * Copyright (C) 2016 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.thema.lucsim.gui.generator.dt;

import java.util.List;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import weka.classifiers.trees.J48;

/**
 * Window dialog which prompts the user for the advanced parameters to use to 
 * build a J48 tree. 
 * Said user is able to choose the following options (default values
 * are bracketed):<br>
 * - the pruning confidence (0.25);<br>
 * - the minimum number of instances per leaf (2);<br>
 * More info can be found at: 
 * http://weka.sourceforge.net/doc.stable/weka/classifiers/trees/J48.html
 */
public class J48TreeSettingsDialog extends javax.swing.JDialog {

    private List<Double> params;

    /**
     * Creates new form DecisionTreeSettingsDialog.
     * @param parent parent Dialog
     * @param params list of parameters, can be empty but cannot be null
     */
    public J48TreeSettingsDialog(JDialog parent, List<Double> params) {
        super(parent, true);
        this.params = params;
        setLocationRelativeTo(parent);
        initComponents();
        setTips();
        
        if(!params.isEmpty()) {
            if(params.get(0) == 1) {
                noPruningRadioButton.setSelected(true);
            } else if(params.get(3) == 1) {
                checkBoxReducedErrorPruning.setSelected(true);
                numFoldsSpinner.setValue(params.get(4).intValue());
            } else {
                pruningConfidenceRadioButton.setSelected(true);
                textFieldPruningConfidence.setText(""+params.get(1));
            }
            textFieldMinimumNumberOfInstances.setText(""+params.get(2));
            checkBoxUseBinarySplitsOnly.setSelected(params.get(5) == 1);
        }

    }

    private void setTips() {
        J48 j48 = new J48();
        labelUseUnprunedTree.setToolTipText(j48.unprunedTipText());
        labelPruningConfidence.setToolTipText(j48.confidenceFactorTipText());
        labelMinimumNumberOfInstances.setToolTipText(j48.minNumObjTipText());
        labelReducedErrorPruning.setToolTipText(j48.reducedErrorPruningTipText());
        labelNumberOfFoldsForErrorPruning.setToolTipText(j48.numFoldsTipText());
        labelUseBinarySplitsOnly.setToolTipText(j48.binarySplitsTipText());
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        bindingGroup = new org.jdesktop.beansbinding.BindingGroup();

        buttonGroup1 = new javax.swing.ButtonGroup();
        textFieldMinimumNumberOfInstances = new javax.swing.JTextField();
        labelUseUnprunedTree = new javax.swing.JLabel();
        labelReducedErrorPruning = new javax.swing.JLabel();
        labelSettings = new javax.swing.JLabel();
        labelNumberOfFoldsForErrorPruning = new javax.swing.JLabel();
        labelPruningConfidence = new javax.swing.JLabel();
        labelMinimumNumberOfInstances = new javax.swing.JLabel();
        labelUseBinarySplitsOnly = new javax.swing.JLabel();
        buttonOK = new javax.swing.JButton();
        checkBoxUseBinarySplitsOnly = new javax.swing.JCheckBox();
        labelTip = new javax.swing.JLabel();
        textFieldPruningConfidence = new javax.swing.JTextField();
        pruningConfidenceRadioButton = new javax.swing.JRadioButton();
        checkBoxReducedErrorPruning = new javax.swing.JRadioButton();
        noPruningRadioButton = new javax.swing.JRadioButton();
        cancelButton = new javax.swing.JButton();
        numFoldsSpinner = new javax.swing.JSpinner();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Tree settings");

        textFieldMinimumNumberOfInstances.setText("2");
        textFieldMinimumNumberOfInstances.setName("textFieldMinimumNumberOfInstances"); // NOI18N

        labelUseUnprunedTree.setText("No pruning");
        labelUseUnprunedTree.setName("labelUseUnprunedTree"); // NOI18N

        labelReducedErrorPruning.setText("Reduced error pruning");
        labelReducedErrorPruning.setName("labelReducedErrorPruning"); // NOI18N

        labelSettings.setFont(new java.awt.Font("Arial", 1, 18)); // NOI18N
        labelSettings.setText("Settings");
        labelSettings.setName("labelSettings"); // NOI18N

        labelNumberOfFoldsForErrorPruning.setText("numberOfFoldsForErrorPruning");
        labelNumberOfFoldsForErrorPruning.setName("labelNumberOfFoldsForErrorPruning"); // NOI18N

        org.jdesktop.beansbinding.Binding binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, checkBoxReducedErrorPruning, org.jdesktop.beansbinding.ELProperty.create("${selected}"), labelNumberOfFoldsForErrorPruning, org.jdesktop.beansbinding.BeanProperty.create("enabled"));
        bindingGroup.addBinding(binding);

        labelPruningConfidence.setText("Pruning confidence");
        labelPruningConfidence.setName("labelPruningConfidence"); // NOI18N

        labelMinimumNumberOfInstances.setText("minimumNumberOfInstancesPerLeaf");
        labelMinimumNumberOfInstances.setName("labelMinimumNumberOfInstances"); // NOI18N

        labelUseBinarySplitsOnly.setText("useBinarySplitsOnly");
        labelUseBinarySplitsOnly.setName("labelUseBinarySplitsOnly"); // NOI18N

        buttonOK.setText("OK");
        buttonOK.setName("buttonOK"); // NOI18N
        buttonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonOKActionPerformed(evt);
            }
        });

        checkBoxUseBinarySplitsOnly.setName("checkBoxUseBinarySplitsOnly"); // NOI18N

        labelTip.setFont(new java.awt.Font("Tahoma", 2, 11)); // NOI18N
        labelTip.setText("(hover over the components to get a tip)");
        labelTip.setName("labelTip"); // NOI18N

        textFieldPruningConfidence.setText("0.25");
        textFieldPruningConfidence.setName("textFieldPruningConfidence"); // NOI18N

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, pruningConfidenceRadioButton, org.jdesktop.beansbinding.ELProperty.create("${selected}"), textFieldPruningConfidence, org.jdesktop.beansbinding.BeanProperty.create("enabled"));
        bindingGroup.addBinding(binding);

        buttonGroup1.add(pruningConfidenceRadioButton);
        pruningConfidenceRadioButton.setSelected(true);
        pruningConfidenceRadioButton.setName("pruningConfidenceRadioButton"); // NOI18N

        buttonGroup1.add(checkBoxReducedErrorPruning);
        checkBoxReducedErrorPruning.setName("checkBoxReducedErrorPruning"); // NOI18N

        buttonGroup1.add(noPruningRadioButton);
        noPruningRadioButton.setName("noPruningRadioButton"); // NOI18N

        cancelButton.setText("Cancel");
        cancelButton.setName("cancelButton"); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        numFoldsSpinner.setModel(new javax.swing.SpinnerNumberModel(Integer.valueOf(3), Integer.valueOf(2), null, Integer.valueOf(1)));
        numFoldsSpinner.setName("numFoldsSpinner"); // NOI18N

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, checkBoxReducedErrorPruning, org.jdesktop.beansbinding.ELProperty.create("${selected}"), numFoldsSpinner, org.jdesktop.beansbinding.BeanProperty.create("enabled"));
        bindingGroup.addBinding(binding);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(labelSettings)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(labelTip)
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(36, 36, 36)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(labelPruningConfidence)
                            .addComponent(labelUseUnprunedTree)
                            .addComponent(labelReducedErrorPruning)
                            .addComponent(labelNumberOfFoldsForErrorPruning)
                            .addComponent(labelUseBinarySplitsOnly))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(pruningConfidenceRadioButton)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(textFieldPruningConfidence, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addComponent(noPruningRadioButton))
                                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(textFieldMinimumNumberOfInstances, javax.swing.GroupLayout.DEFAULT_SIZE, 63, Short.MAX_VALUE)
                                    .addComponent(checkBoxReducedErrorPruning)
                                    .addComponent(checkBoxUseBinarySplitsOnly)
                                    .addComponent(numFoldsSpinner))
                                .addGap(0, 0, Short.MAX_VALUE))))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(labelMinimumNumberOfInstances)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(buttonOK, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(cancelButton)
                        .addGap(40, 40, 40))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelSettings)
                    .addComponent(labelTip))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelUseUnprunedTree)
                    .addComponent(noPruningRadioButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(textFieldPruningConfidence, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(labelPruningConfidence)
                        .addComponent(pruningConfidenceRadioButton)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelReducedErrorPruning)
                    .addComponent(checkBoxReducedErrorPruning))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelNumberOfFoldsForErrorPruning)
                    .addComponent(numFoldsSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(checkBoxUseBinarySplitsOnly)
                    .addComponent(labelUseBinarySplitsOnly))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelMinimumNumberOfInstances)
                    .addComponent(textFieldMinimumNumberOfInstances, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 27, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonOK)
                    .addComponent(cancelButton))
                .addContainerGap())
        );

        bindingGroup.bind();

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void buttonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOKActionPerformed
        if ((textFieldPruningConfidence.getText().equals(""))
            || (textFieldMinimumNumberOfInstances.getText().equals(""))) {
            JOptionPane.showMessageDialog(this, "At least one field is not filled.");
        } else {
            params.clear();
            params.add(noPruningRadioButton.isSelected() ? 1.0 : 0.0);
            params.add(Double.valueOf(textFieldPruningConfidence.getText()));
            params.add(Double.valueOf(textFieldMinimumNumberOfInstances.getText()));
            params.add(checkBoxReducedErrorPruning.isSelected() ? 1.0 : 0.0);
            params.add(((Number)numFoldsSpinner.getValue()).doubleValue());
            params.add(checkBoxUseBinarySplitsOnly.isSelected() ? 1.0 : 0.0);

            setVisible(false);
            dispose();
        }
    }//GEN-LAST:event_buttonOKActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton buttonOK;
    private javax.swing.JButton cancelButton;
    private javax.swing.JRadioButton checkBoxReducedErrorPruning;
    private javax.swing.JCheckBox checkBoxUseBinarySplitsOnly;
    private javax.swing.JLabel labelMinimumNumberOfInstances;
    private javax.swing.JLabel labelNumberOfFoldsForErrorPruning;
    private javax.swing.JLabel labelPruningConfidence;
    private javax.swing.JLabel labelReducedErrorPruning;
    private javax.swing.JLabel labelSettings;
    private javax.swing.JLabel labelTip;
    private javax.swing.JLabel labelUseBinarySplitsOnly;
    private javax.swing.JLabel labelUseUnprunedTree;
    private javax.swing.JRadioButton noPruningRadioButton;
    private javax.swing.JSpinner numFoldsSpinner;
    private javax.swing.JRadioButton pruningConfidenceRadioButton;
    private javax.swing.JTextField textFieldMinimumNumberOfInstances;
    private javax.swing.JTextField textFieldPruningConfidence;
    private org.jdesktop.beansbinding.BindingGroup bindingGroup;
    // End of variables declaration//GEN-END:variables
}
